;;; example provided by Luis Esquivel July 2001
;;; to emulate the same ability of A2Ki

(if (car (atoms-family 1 '("vl-load-com")))
  (vl-load-com)
)

(cond
  ((and *adocobj* (= (vl-symbol-name (type *adocobj*)) "VLA-OBJECT")) *adocobj*)
  ((setq *adocobj* (vla-get-activedocument (vlax-get-acad-object))))
)

(defun mouse-reactor (data)
  (setq reactor
    (vlr-mouse-reactor
      data
      '(
        (:vlr-begindoubleclick
         .
         mouse-begindoubleclick
        )
      )
    )
  )
  (vlr-set-notification reactor 'active-document-only)
  (princ)
)

(defun mouse-begindoubleclick (obj lst / ent gr ss p1 typ)
  (if (and lst (zerop (getvar "cmdactive")))
    (progn
      (setq ss (ssget "i")
            ss2 (car (nentselp (car lst)))
      )
      (if (and ss (= 'PICKSET (type ss))(= (sslength ss) 1)(zerop (getvar "cmdactive")))
        (progn
          (setq ent (entget (ssname ss 0))
                typ (cdr (assoc 0 ent))
                lyr (cdr (assoc 8 ent))
          )
          (cond
            ( (and
                (or
;                  (= typ "TEXT")
                  (= typ "MTEXT")
                  (= typ "ATTDEF")
                  (= typ "DIMENSION")
                )
;                (or
;                  (= (cdr (assoc 0 (entget ss2))) "TEXT")
                  (= (cdr (assoc 0 (entget ss2))) "MTEXT")
;                )
              )
              (vla-sendcommand *adocobj* "_.ddedit ")
            )
            ( (or
                (= typ "DIMENSION")
                (= typ "LEADER")
              )
              (vla-sendcommand *adocobj* "_.properties ")
            )
            ( (= typ "TEXT")
              (if (member "doslib2k.arx" (arx))(dos_capslock T))
              (vla-sendcommand *adocobj* "_.ddmodify ")
              (if (member "doslib2k.arx" (arx))(dos_capslock))
            )
            ( (= typ "MLINE")
              (vla-sendcommand *adocobj* "_.mledit ")
            )
            ( (= typ "HATCH")
              (vla-sendcommand *adocobj* "_.hatchedit ")
            )
            ( (= typ "ATTDEF")
              (vla-sendcommand *adocobj* "_.ddmodify ")
            )
            ( (= typ "LINE") ;; start line command...
              (vla-setvariable *adocobj* "clayer" lyr)
              (vla-sendcommand *adocobj* "_.line ")
            )
            ( (= (cdr (assoc 0 (entget ss2))) "ATTRIB")
              (vla-sendcommand *adocobj* (strcat "_.attedit " (list->str (mapcar '(lambda (x)(rtos x))(car lst)) ",") " "))
            )
            ( (= typ "INSERT")
              (vla-sendcommand *adocobj* (strcat "_.refedit " (list->str (mapcar '(lambda (x)(rtos x))(car lst)) ",") " "))
            )

            ( (= typ "LWPOLYLINE")
              (initget 8 "E EDIT")
              (setq p1 (getpoint "\nPick first point of LWPolyline or type \"E\" to Edit: "))
              (cond
                ( (= 'STR (type p1))
                  (vla-sendcommand *adocobj* "_.pedit ")
                )
                ( (= 'LIST (type p1))
                  (vla-setvariable *adocobj* "clayer" lyr)
                  (vla-sendcommand *adocobj* (strcat "_.pline\n" (list->str (mapcar '(lambda (x)(vl-princ-to-string x)) p1) ",") " "))
                )
              )
            )
;|
            ( (= typ "LWPOLYLINE")
              (princ "\nPick first point of LWPolyline or type \"E\" to Edit: ")
              (while
                (not
                  (or
                    (equal gr '(2 13))
                    (equal gr '(2 69))
                    (equal gr '(2 101))
                    (equal gr '(11 0))
                    (equal (car gr) 3)
                  )
                )
                (setq gr (grread nil 14 3))
              )
              (cond
                ( (= (car gr) 3)
                  (vla-setvariable *adocobj* "clayer" lyr)
                  (vla-sendcommand *adocobj* (strcat "_.pline " (list->str (mapcar '(lambda (x)(rtos x))(cadr gr)) ",") " "))
                )
                ( T
                  (princ (strcat (chr (cadr gr)) "\n"))
                  (vla-sendcommand *adocobj* "_.pedit ")
                )
              )
            )
|;
          )
        )
        (cond
            ( (and ss2 (acet-sys-shift-down))
              (vla-setvariable *adocobj* "clayer" (cdr (assoc 8 (entget (car (nentselp (car lst)))))))
              (sssetfirst nil nil)
            )
            (T (vla-sendcommand *adocobj* "_.pan "))
         )
      )
    )
  )
  (princ)
)

(defun mouse-remove-layering-system ()
  (if (vlr-reactors :vlr-mouse-reactor)
    (progn
      (vlr-remove-all :vlr-mouse-reactor)
      (setq reactor nil)
    )
  )
  (princ)
)

(defun mouse-load-layering-system ()
  (if mouse-reactor
    (mouse-reactor nil)
  )
  (princ)
)

(mouse-remove-layering-system)
(mouse-load-layering-system)

(princ)